
int SCIsNotdef(SplineChar *sc,int fixed) {
return( sc!=NULL && sc->layers[ly_fore].refs==NULL && strcmp(sc->name,".notdef")==0 &&
	(sc->layers[ly_fore].splines!=NULL || (sc->widthset && fixed==-1) ||
	 (sc->width!=sc->parent->ascent+sc->parent->descent && fixed==-1 ) ||
	 (sc->width==fixed && fixed!=-1 && sc->widthset)));
}

static void BDFsToo(SplineFont *sf,int cnt) {
    BDFFont *bdf;
    BDFChar **newbc;
    int i;

    for ( bdf=sf->bitmaps; bdf!=NULL; bdf=bdf->next ) {
	newbc = gcalloc(cnt,sizeof(BDFChar *));
	for ( i=0; i<bdf->glyphcnt; ++i ) if ( bdf->glyphs[i]!=NULL ) {
	    int pos = bdf->glyphs[i]->sc->orig_pos;
	    newbc[pos] = bdf->glyphs[i];
	    newbc[pos]->orig_pos = pos;
	}
	free(bdf->chars);
	bdf->glyphs = newbc;
	bdf->glyphcnt = cnt;
    }
}

static void _SFCompactFont(SplineFont *sf) {
    int i, cnt;
    SplineChar **newchars;
 
    for ( i=cnt=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL ) {
	sf->chars[i]->old_enc = i;
	++cnt;
    }
    newchars = galloc(cnt*sizeof(SplineChar *));
    for ( i=cnt=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL ) {
	newchars[cnt] = sf->chars[i];
	newchars[cnt]->enc = cnt;
	++cnt;
    }
    free(sf->chars);
    sf->chars = newchars;
    sf->charcnt = cnt;
    sf->old_encname = sf->encoding_name;
    sf->encoding_name = &compact;
    sf->compacted = true;
    sf->encodingchanged = true;
    BDFsToo(sf,cnt);
}

int SFCompactFont(SplineFont *sf) {
    MMSet *mm = sf->mm;
    int i;

    if ( sf->compacted )
return( false );

    SFFindNearTop(sf);

    if ( mm==NULL )
	_SFCompactFont(sf);
    else {
	for ( i=0; i<mm->instance_count; ++i )
	    _SFCompactFont(mm->instances[i]);
	_SFCompactFont(mm->normal);
    }

    SFRestoreNearTop(sf);
return( true );
}

static void _SFUncompactFont(SplineFont *sf) {
    int i,cnt;
    SplineChar **newchars;

    cnt = 0;
    for ( i=sf->charcnt-1; i>=0; --i ) if ( sf->chars[i]!=NULL ) {
	cnt = sf->chars[i]->old_enc+1;
    break;
    }
    if ( (i=CountOfEncoding(sf->old_encname))>cnt )
	cnt = i;
    if ( cnt==0 )
return;

    newchars = gcalloc(cnt,sizeof(SplineChar *));
    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL ) {
	int enc = sf->chars[i]->old_enc;
	if ( enc>=cnt ) {
	    IError("Compacted font isn't" );
	    free( newchars );
return;
	}
	newchars[enc] = sf->chars[i];
	newchars[enc]->enc = enc;
    }
    free(sf->chars);
    sf->chars = newchars;
    sf->charcnt = cnt;
    sf->encoding_name = sf->old_encname;
    sf->compacted = false;
    sf->encodingchanged = true;

    BDFsToo(sf,cnt);
}

int SFUncompactFont(SplineFont *sf) {
    int i, cnt;
    MMSet *mm = sf->mm;

    if ( !sf->compacted )
return( false );
    cnt = 0;
    for ( i=sf->charcnt-1; i>=0; --i ) if ( sf->chars[i]!=NULL ) {
	cnt = sf->chars[i]->old_enc+1;
    break;
    }
    if ( cnt==0 )
return( false );

    SFFindNearTop(sf);

    if ( mm==NULL )
	_SFUncompactFont(sf);
    else {
	for ( i=0; i<mm->instance_count; ++i )
	    _SFUncompactFont(mm->instances[i]);
	_SFUncompactFont(mm->normal);
    }

    SFRestoreNearTop(sf);
return( true );
}

static int AskTooFew() {
#if defined(FONTFORGE_CONFIG_GDRAW)
    static int buts[] = { _STR_OK, _STR_Cancel, 0 };
return( GWidgetAskR(_STR_Toofew,buts,0,1,_STR_Reducing) );
#elif defined(FONTFORGE_CONFIG_GTK)
    static char *buts[] = { GTK_STOCK_OK, GTK_STOCK_CANCEL, NULL };
return( gwwv_ask(_("Too Few Characters"),buts,0,1,_("You are reducing the number of characters below the\ncurrent number. This will delete some characters.\nIs that what you wish to do?")) );
#endif
}

static void _SFAddDelChars(SplineFont *sf, int nchars) {
    int i;
    BDFFont *bdf;
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
    MetricsView *mv, *mnext;
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */

    if ( nchars==sf->charcnt )
return;
    if ( nchars>sf->charcnt ) {
	sf->chars = grealloc(sf->chars,nchars*sizeof(SplineChar *));
	for ( i=sf->charcnt; i<nchars; ++i )
	    sf->chars[i] = NULL;
	sf->charcnt = nchars;
	for ( bdf=sf->bitmaps; bdf!=NULL; bdf=bdf->next ) {
	    bdf->chars = grealloc(bdf->chars,nchars*sizeof(BDFChar *));
	    for ( i=bdf->charcnt; i<nchars; ++i )
		bdf->chars[i] = NULL;
	    bdf->charcnt = nchars;
	}
    } else {
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
	if ( sf->fv->metrics!=NULL ) {
	    for ( mv=sf->fv->metrics; mv!=NULL; mv = mnext ) {
		mnext = mv->next;
		GDrawDestroyWindow(mv->gw);
	    }
	    GDrawSync(NULL);
	    GDrawProcessPendingEvents(NULL);
	    GDrawSync(NULL);
	    GDrawProcessPendingEvents(NULL);
	}
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */
	for ( i=nchars; i<sf->charcnt; ++i ) {
	    RemoveSplineChar(sf,i);
	}
	sf->charcnt = nchars;
	if ( nchars<sf->encoding_name->char_cnt ) sf->encoding_name = &custom;
	for ( bdf=sf->bitmaps; bdf!=NULL; bdf=bdf->next ) {
	    bdf->charcnt = nchars;
	    bdf->encoding_name = sf->encoding_name;
	}
    }
    GlyphHashFree(sf);
}

int SFAddDelChars(SplineFont *sf, int nchars) {
    int i;
    MMSet *mm = sf->mm;

    if ( nchars==sf->charcnt )
return( false );

    if ( mm==NULL )
	_SFAddDelChars(sf,nchars);
    else {
	for ( i=0; i<mm->instance_count; ++i )
	    _SFAddDelChars(mm->instances[i],nchars);
	_SFAddDelChars(mm->normal,nchars);
    }
return( true );
}

static void RemoveSplineChar(SplineFont *sf, int enc) {
    struct splinecharlist *dep, *dnext;
    BDFFont *bdf;
    BDFChar *bfc;
    SplineChar *sc = sf->chars[enc];
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
    CharView *cv, *next;
    BitmapView *bv, *bvnext;
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */
    RefChar *refs, *rnext;
    FontView *fvs;
    KernPair *kp, *kprev;
    int i;

    if ( sc!=NULL ) {
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
	if ( sc->views ) {
	    for ( cv = sc->views; cv!=NULL; cv=next ) {
		next = cv->next;
		GDrawDestroyWindow(cv->gw);
	    }
	    GDrawSync(NULL);
	    GDrawProcessPendingEvents(NULL);
	    GDrawSync(NULL);
	    GDrawProcessPendingEvents(NULL);
	}
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */
	for ( dep=sc->dependents; dep!=NULL; dep=dnext ) {
	    SplineChar *dsc = dep->sc;
	    RefChar *rf, *rnext;
	    dnext = dep->next;
	    /* May be more than one reference to us, colon has two refs to period */
	    /*  but only one dlist entry */
	    for ( rf = dsc->layers[ly_fore].refs; rf!=NULL; rf=rnext ) {
		rnext = rf->next;
		if ( rf->sc==sc )
		    SCRefToSplines(dsc,rf);
	    }
	}
	for ( fvs=sc->parent->fv; fvs!=NULL; fvs=fvs->nextsame ) {
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
	    if ( fvs->sv!=NULL ) {
		RefChar *rf, *rnext;
		for ( rf = fvs->sv->sc_srch.layers[ly_fore].refs; rf!=NULL; rf=rnext ) {
		    rnext = rf->next;
		    if ( rf->sc==sc )
			SCRefToSplines(&fvs->sv->sc_srch,rf);
		}
		for ( rf = fvs->sv->sc_rpl.layers[ly_fore].refs; rf!=NULL; rf=rnext ) {
		    rnext = rf->next;
		    if ( rf->sc==sc )
			SCRefToSplines(&fvs->sv->sc_rpl,rf);
		}
	    }
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */
	    /* Are there any kerning pairs that look at this character? */
	    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL ) {
		for ( kprev=NULL, kp=sf->chars[i]->kerns; kp!=NULL; kprev = kp, kp=kp->next ) {
		    if ( kp->sc==sc ) {
			if ( kprev==NULL )
			    sf->chars[i]->kerns = kp->next;
			else
			    kprev->next = kp->next;
			kp->next = NULL;
			KernPairsFree(kp);
		break;
		    }
		}
	    }
	}
	sf->chars[enc] = NULL;
	SplineCharFree(sc);
    }

    for ( bdf=sf->bitmaps; bdf!=NULL; bdf = bdf->next ) {
	if ( (bfc = bdf->chars[enc])!= NULL ) {
	    bdf->chars[enc] = NULL;
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
	    if ( bfc->views!=NULL ) {
		for ( bv= bfc->views; bv!=NULL; bv=bvnext ) {
		    bvnext = bv->next;
		    GDrawDestroyWindow(bv->gw);
		}
		GDrawSync(NULL);
		GDrawProcessPendingEvents(NULL);
		GDrawSync(NULL);
		GDrawProcessPendingEvents(NULL);
	    }
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */
	    BDFCharFree(bfc);
	}
    }
}

static void SFToPUA(SplineFont *sf) {
    int i, j;
    extern const int cns14pua[], amspua[];
    const int *pua;
    int low, high;
    BDFFont *bdf;

    if ( sf->uni_interp==ui_trad_chinese ) {
	pua = cns14pua;
	low = 0x20000;
	high = 0x2ffff;
    } else {
	pua = amspua;
	low = 0x1d400;
	high = 0x1d7ff;
    }

    for ( i=low; i<sf->charcnt && i<=high; ++i ) {
	if ( sf->chars[i]!=NULL ) {
	    for ( j=0xf8ff-0xe000; j>=0; --j )
		if ( pua[j] == i )
	    break;
	    if ( j>=0 ) {
		j += 0xe000;
		if ( sf->chars[j]!=NULL ) {
		    sf->chars[j] = sf->chars[i];
		    sf->chars[i] = NULL;
		    sf->chars[j]->unicodeenc = j;
		    sf->chars[j]->enc = j;
		    for ( bdf=sf->bitmaps; bdf!=NULL; bdf=bdf->next ) {
			if ( j<bdf->charcnt && bdf->chars[j]==NULL && bdf->chars[i]!=NULL ) {
			    bdf->chars[j] = bdf->chars[i];
			    bdf->chars[i] = NULL;
			    bdf->chars[j]->enc = j;
			}
		    }
		}
	    }
	}
    }
}

static void SFFromPUA(SplineFont *sf) {
    int i, j;
    extern const int cns14pua[], amspua[];
    const int *pua = sf->uni_interp==ui_trad_chinese ? cns14pua : amspua;
    BDFFont *bdf;

    for ( i=0xe000; i<sf->charcnt && i<=0xf8ff; ++i ) {
	if ( sf->chars[i]!=NULL && (j=pua[i-0xe000])>0x10000 && j<sf->charcnt &&
		sf->chars[j]==NULL ) {
	    sf->chars[j] = sf->chars[i];
	    sf->chars[i] = NULL;
	    sf->chars[j]->unicodeenc = j;
	    sf->chars[j]->enc = j;
	    for ( bdf=sf->bitmaps; bdf!=NULL; bdf=bdf->next ) {
		if ( j<bdf->charcnt && bdf->chars[j]==NULL && bdf->chars[i]!=NULL ) {
		    bdf->chars[j] = bdf->chars[i];
		    bdf->chars[i] = NULL;
		    bdf->chars[j]->enc = j;
		}
	    }
	}
    }
}

static int intarget(SplineChar *sc, SplineFont *target) {
    sc->enc = SFFindChar(target,sc->unicodeenc,sc->name);
return( sc->enc!=-1 );
}

static int infont(SplineChar *sc, uint8 *used, Encoding *new_enc) {
    int enc = -1;

    if ( sc->unicodeenc!=-1 )
	enc = EncFromUni(sc->unicodeenc,new_enc);
    else if ( new_enc->psnames!=NULL ) {
	for ( enc = new_enc->char_cnt-1; enc>=0; --enc ) if ( new_enc->psnames[enc]!=NULL )
	    if ( strcmp(sc->name,new_enc->psnames[enc])==0 )
	break;
    }

    if ( enc!=-1 ) {
	if ( used[enc>>3] & (1<<(enc&7)) )
	    enc = -1;
	else
	    used[enc>>3] |= (1<<(enc&7));
    } else if ( SCIsNotdef(sc,-1) && !(used[0]&1) ) {
	enc = 0;
	used[0] |= 1;
    }
    sc->enc = enc;
return( enc!=-1 );
}

static int __SFReencodeFont(SplineFont *sf,Encoding *new_enc, SplineFont *target);

static EncMap *
static int __SFReencodeFont(SplineFont *sf,Encoding *new_enc,
	SplineFont *target) {
    int i, enc_cnt, extras=0, epos;
    SplineChar **chars;
    BDFFont *bdf;
    uint8 *used;
    RefChar *refs;
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
    CharView *cv;
#endif

    if ( target!=NULL ) {
	if ( target->encoding_name==sf->encoding_name )
return( false );
	enc_cnt = target->charcnt;
    } else {
	if ( sf->encoding_name==new_enc )
return( false );
	if ( sf->encoding_name->is_unicodefull &&
		(sf->uni_interp==ui_ams || sf->uni_interp==ui_trad_chinese))
	    SFToPUA(sf);
	if ( new_enc->is_custom ) {
	    sf->encoding_name=new_enc;	/* Custom, it's whatever's there */
return(false);
	}
	enc_cnt = new_enc->char_cnt;
	if ( new_enc->is_original ) {
	    int tlen = 0;
	    /* Make sure that every glyph has an original pos (some might have*/
	    /*  been added, or one glyph might be encoded twice */
	    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL && sf->chars[i]->orig_pos!=0xffff )
		if ( sf->chars[i]->orig_pos>tlen ) tlen = sf->chars[i]->orig_pos;
	    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL )
		if ( sf->chars[i]->orig_pos==0xffff )
		    sf->chars[i]->orig_pos = ++tlen;
	    enc_cnt = tlen+1;
	}
    }

#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL ) {
	for ( cv=sf->chars[i]->views; cv!=NULL; cv=cv->next )
	    cv->template1 = cv->template2 = NULL;
    }
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */

    if ( target==NULL && new_enc->is_original ) {
	for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL )
	    sf->chars[i]->enc = sf->chars[i]->orig_pos;
    } else {
	used = gcalloc((enc_cnt+7)/8,sizeof(uint8));
	for ( i=0; i<sf->charcnt; ++i ) {
	    SplineChar *sc = sf->chars[i];
	    if ( sc==NULL )
	continue;
	    if ( sc->layers[ly_fore].splines==NULL && sc->layers[ly_fore].refs==NULL && sc->dependents==NULL &&
		    (!sc->widthset || strcmp(sc->name,".notdef")==0 ) ) {
		    /* glyphs mapped to .notdef in a type1 font will have widthset but its not meaningful */
		RemoveSplineChar(sf,i);
	    } else if ( (target==NULL && !infont(sc,used,new_enc)) ||
		      (target!=NULL && !intarget(sc,target) ) ) {
		++extras;
	    }
	}
	free(used);
    }

    chars = gcalloc(enc_cnt+extras,sizeof(SplineChar *));
    for ( bdf=sf->bitmaps; bdf!=NULL; bdf = bdf->next )
	bdf->temp = gcalloc(enc_cnt+extras,sizeof(BDFChar *));
    for ( i=0, epos=enc_cnt; i<sf->charcnt; ++i ) {
	if ( sf->chars[i]==NULL )
	    /* skip */;
	else {
	    if ( sf->chars[i]->enc==-1 )
		sf->chars[i]->enc = epos++;
	    if ( chars[sf->chars[i]->enc]!=NULL )
		fprintf( stderr, "Warning: Two chars (%s,%s) mapped to the same encoding %d\n",
			chars[sf->chars[i]->enc]->name, sf->chars[i]->name,
			sf->chars[i]->enc );
	    chars[sf->chars[i]->enc] = sf->chars[i];
	    for ( bdf=sf->bitmaps; bdf!=NULL; bdf = bdf->next ) {
		if ( i<bdf->charcnt && bdf->chars[i]!=NULL && sf->chars[i]!=NULL ) {
		    bdf->chars[i]->enc = sf->chars[i]->enc;
		    bdf->temp[sf->chars[i]->enc] = bdf->chars[i];
		}
	    }
	}
    }
    if ( epos!=enc_cnt+extras ) IError( "Bad count in ReencodeFont");
    free(sf->chars);
    sf->chars = chars;
    sf->charcnt = enc_cnt+extras;
    sf->encoding_name = new_enc;
    for ( bdf=sf->bitmaps; bdf!=NULL; bdf = bdf->next ) {
	free(bdf->chars);
	bdf->chars = bdf->temp;
	bdf->temp = NULL;
	bdf->charcnt = enc_cnt+extras;
	bdf->encoding_name = new_enc;
    }

    if ( sf->encoding_name->is_unicodefull && (sf->uni_interp==ui_ams || sf->uni_interp==ui_trad_chinese))
	SFFromPUA(sf);
    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL ) {
	for ( refs=sf->chars[i]->layers[ly_fore].refs; refs!=NULL; refs = refs->next )
	    refs->local_enc = refs->sc->enc;
    }

    /* Make sure we end up with the right names in encodings where the */
    /*  glyph names are important (not just the right unicode code points) */
    if ( target==NULL && new_map!=NULL && new_map->psnames )
	_SFForceEncoding(sf,new_map);

    free(sf->remap);
    sf->remap = NULL;
    sf->encodingchanged = true;
    sf->compacted = false;
#ifndef FONTFORGE_CONFIG_NO_WINDOWING_UI
    for ( i=0; i<sf->charcnt; ++i ) if ( sf->chars[i]!=NULL )
	SCRefreshTitles(sf->chars[i]);
#endif		/* FONTFORGE_CONFIG_NO_WINDOWING_UI */
return( true );
}

static int _SFReencodeFont(SplineFont *sf,Encoding *new_enc, SplineFont *target) {
    MMSet *mm = sf->mm;
    int i, ret;

    SFFindNearTop(sf);

    if ( mm==NULL )
	ret = __SFReencodeFont(sf,new_enc,target);
    else {
	ret = false;
	for ( i=0; i<mm->instance_count; ++i )
	    ret |= __SFReencodeFont(mm->instances[i],new_enc,target);
	ret |= __SFReencodeFont(mm->normal,new_enc,target);
    }

    SFRestoreNearTop(sf);
return( ret );
}

int SFForceEncoding(SplineFont *sf,Encoding *new_enc) {
    if ( sf->mm!=NULL ) {
	MMSet *mm = sf->mm;
	int i;
	for ( i=0; i<mm->instance_count; ++i )
	    _SFForceEncoding(mm->instances[i],new_enc);
	_SFForceEncoding(mm->normal,new_enc);
    } else
return( _SFForceEncoding(sf,new_enc));

return( true );
}

int SFReencodeFont(SplineFont *sf,Encoding *new_enc) {
    if ( new_enc->is_compact )
return( SFCompactFont(sf));
    else if ( sf->compacted && new_enc==sf->old_encname )
return( SFUncompactFont(sf));
    else
return( _SFReencodeFont(sf,new_enc,NULL));
}
